﻿using System;
using System.Linq;
using Telerik.XamarinForms.Common;
using Telerik.XamarinForms.Common.DataAnnotations;
using Telerik.XamarinForms.Input;
using Xamarin.Forms;

namespace Sample
{
    public partial class Page1 : ContentPage
    {
        public Page1()
        {
            InitializeComponent();
            this.BindingContext = new RefinanceCostBenefitAnalysisCalculatorModel();

            dataForm.RegisterEditor("NumberOfPaymentsAlreadyMade", EditorType.IntegerEditor);
            dataForm.RegisterEditor("ActualFirstPaymentDate", EditorType.DateEditor);
            dataForm.RegisterEditor("InitialLoanAmount", EditorType.DecimalEditor);
        }
    }

    public class RefinanceCostBenefitAnalysisCalculatorModel : NotifyPropertyChangedBase
    {
        private decimal _initialLoanAmount;
        private DateTime _actualFirstPaymentDate;
        private int _numberOfPaymentsAlreadyMadeDecimal;

        [DisplayOptions(Header = "What was your Initial Loan Amount?", PlaceholderText = "Enter Amount", Position = 1)]
        [NonEmptyValidator]
        [Converter(typeof(DecimalToDoubleConverter))]
        public decimal InitialLoanAmount
        {
            get
            {
                return this._initialLoanAmount;
            }
            set
            {
                if (this._initialLoanAmount != value)
                {
                    this._initialLoanAmount = value;
                    this.OnPropertyChanged();
                }
            }
        }

        [DisplayOptions(Header = "When was the Actual First payment date?", PlaceholderText = "Enter First payment date", Position = 2)]
        [NonEmptyValidator]
        public DateTime ActualFirstPaymentDate
        {
            get
            {
                return this._actualFirstPaymentDate;
            }
            set
            {
                if (this._actualFirstPaymentDate != value)
                {
                    this._actualFirstPaymentDate = value;
                    this.OnPropertyChanged();
                }
            }
        }

        [DisplayOptions(Header = "How many Payments have you Already Made?", PlaceholderText = "Enter Number of Payments", Position = 3)]
        [NonEmptyValidator]
        public int NumberOfPaymentsAlreadyMade
        {
            get
            {
                return this._numberOfPaymentsAlreadyMadeDecimal;
            }
            set
            {
                if (this._numberOfPaymentsAlreadyMadeDecimal != value)
                {
                    this._numberOfPaymentsAlreadyMadeDecimal = value;
                    this.OnPropertyChanged();
                }
            }
        }
    }
}